<?php

// FractalMeet 1.0 
// Copyright Mikael Cromsjö 2021


//DATA

	define("DATAPATH", "./dat/"); // Any directory outside htdocs (if you want it to be more secure)

	ini_set('display_errors', 0);
	ini_set('display_startup_errors', 0);
	error_reporting(0);
	if ($debug) {
		ini_set('display_errors', 1);
		ini_set('display_startup_errors', 1);
		error_reporting(E_ALL & ~E_NOTICE);
	}
		
	class fractal {
		public function __construct($id){
			$this->id = $id;
			$this->loadConfig();
		}

		public $debug = true;
		public $config;
		public $id;
			
		public function loadConfig() {
			$handle = fopen(DATAPATH.$this->id."-"."config.dat", "rb");
			$contents = stream_get_contents($handle);
			fclose($handle);
			$this->config = json_decode($contents);

			$time = 0;
			foreach ($this->config->startDates as $dates) {
				$dates = (array) $dates;
				$_layer = $dates['layer'];
				
				
				if ($demo) {
					//Demo every 25 min today
					$time += 25;
					$startTime = time();
					$dates['date'] = date("Y-m-d H:".$time, $startTime) . " CET";
				}
				
				$_meeting = $dates['meeting'];
				$_date = $dates['date'];
				$this->config->startDate[$_layer][$_meeting] = $_date;
			}			
			
			return $this->config;
		}
		
		public function importContribs($layer, $meeting, $groupId, $groupData) {	
			// get all user of this group
			$users = $groupData->users;
			$totalContribs = 0;
			foreach ($users as $user)
			{			
				// load all prev group data
				$_userData = $this->getUserData($user->userId);
				$_prevGroupData = $this->getGroupData($layer-1, $_userData->layer->{$layer-1}->meetingId, $_userData->layer->{$layer-1}->groupId);
				$_contrib = (array) $_prevGroupData->contrib;
				$totalContribs += count($_contrib["titles"]);
				$prevContrib[] = $_contrib;
			}

			$i=0;
			$users = count($users);
			$count = 0;

			while ($count < $totalContribs && $i<100) {
				for ($j=0; $j<$users; $j++){
					if (isset($prevContrib[$j]["titles"][$i])) {
						$titles[] = $prevContrib[$j]["titles"][$i];
						$desc[] = $prevContrib[$j]["desc"][$i];
						$genids[] = $prevContrib[$j]["genids"][$i];
						$count++;
					}
				}
				$i++;	
			}
			$contrib["titles"] = $titles;
			$contrib["desc"] = $desc;
			$contrib["genids"] = $genids;
			$groupData->contrib = $contrib;
			$groupData->import = true;
			
			$this->updateGroupData($layer, $meeting, $groupId, $groupData);
		}		
							
		public function equalizeGroups($layer, $meeting) {
			// get last group
			$groups = $this->getGroupCount($layer, $meeting);
			$groupId = $groups;
			$groupData = $this->getGroupData($layer, $meeting, $groupId);
			if (!isset($groupData) || $groups < 2) {
				return;
			}
			// move users to equalize group size
			$groupSize = count($groupData->users);
			if ($groupSize==1) {
				$this->moveUser($layer, $meeting, $groupId, $groupId-1);
			} else
			if ($groups >= ($this->config->groupSize-$groupSize)-1) {
				// move user from previous groups this one
				for($i=1; $i<=($this->config->groupSize-$groupSize)-1; $i++) {
					if ($groups==$i){
						break;
					}
					$this->moveUser($layer, $meeting, $groupId-$i, $groupId);
				}
			}
			else
			{
				// move users to previous groups, repeat untill no more users in group
				$move = 0;
				echo $groupSize;
				while ($move < $groupSize) {
					for($i=1; $i<=$groupSize; $i++) {
						if ($groups==$i) {
							break;
						}
						$this->moveUser($layer, $meeting, $groupId, $groupId-$i);
						$move++;
					}
				}
			}
		}
		public function moveUser($layer, $meeting, $fromGroupId, $toGroupId) {
			$fromGroupData = $this->getGroupData($layer, $meeting, $fromGroupId);
			$toGroupData = $this->getGroupData($layer, $meeting, $toGroupId);
			$fromUsers = (array) $fromGroupData->users;
			$toUsers = (array) $toGroupData->users;
			$user = array_pop($fromUsers);
			$userData = $this->getUserData($user->userId);
			$userData->layer->{$layer}->groupId = $toGroupId;
			$this->updateUserData($user->userId, $userData);
			$toUsers[] = $user;
			$fromGroupData->users=$fromUsers;
			$toGroupData->users=$toUsers;
			$this->updateGroupData($layer, $meeting, $fromGroupId, $fromGroupData);
			$this->updateGroupData($layer, $meeting, $toGroupId, $toGroupData);
		}
			
		public function calcRep($groupData) {
			foreach ($groupData->users as $groupUserId) {
//				if ($groupUserId->userId == $userData->userId) {
//					$selected = $groupUserId->repId;
//				}
				$user = $this->getUserData($groupUserId->repId);
				if ($user && $user->userId) {
					$reps->{$user->userId} ++;
				}								
			}
			$rep = "";
			$votes = 0;
			foreach ($reps as $k => $v) {
				if ($v > $votes) {
					$rep = $k;
					$votes = $v;
				}
			}
			
			return $rep;
		}
		public function calcSec($groupData) {
			foreach ($groupData->users as $groupUserId) {
//				if ($groupUserId->userId == $userData->userId) {
//					$selected = $groupUserId->secId;
//				}
				$user = $this->getUserData($groupUserId->secId);
				if ($user && $user->userId) {
					$secs->{$user->userId} ++;
				}								
			}
			$sec = "";
			$votes = 0;
			foreach ($secs as $k => $v) {
				if ($v > $votes) {
					$sec = $k;
					$votes = $v;
				}
			}
			return $sec;
		}
		public function getUsers() {	
			if (!file_exists(DATAPATH.$this->id."-"."users.dat")) {
				$handle = fopen(DATAPATH.$this->id."-"."users.dat", "w");
				fclose($handle);
			}
			$handle = fopen(DATAPATH.$this->id."-"."users.dat", "rb");
			$contents = stream_get_contents($handle);
			fclose($handle);
			return $users = explode("\n", $contents);
		}
		public function getUserData($userId) {
			$users = $this->getUsers();
			$key = array_search("userId:".$userId, $users);
			if ($key===false) {
				return false;
			}
			$data = $users[$key+1];
			return json_decode($data);
		}
		public function updateUserData($userId, $userData) {
						
			$users = $this->getUsers();
			$key = array_search("userId:".$userId, $users);
			if ($key === false) {
				$myfile = fopen(DATAPATH.$this->id."-"."users.dat", "a") or die("Unable to open file!");
				flock($myfile, LOCK_EX) or die("Unable to lock file");
				fwrite($myfile, "userId:" . $userId . "\n");
				fwrite($myfile, json_encode($userData) . "\n");
				fflush($myfile);
				flock($myfile, LOCK_UN);
				fclose($myfile);
			}
			else {
				$users[$key+1] = json_encode($userData);
				$myfile = fopen(DATAPATH.$this->id."-"."users.dat", "w");
				flock($myfile, LOCK_EX) or die("Unable to lock file");
				foreach($users as $line) {
					if ($line > "") {
						fwrite($myfile, $line . "\n");
					}
				}
				fflush($myfile);
				flock($myfile, LOCK_UN);
				fclose($myfile);
			}
		}
		
		public function sendLoginForm(){
			echo '
				<p>
				<form action=' . $_SERVER["PHP_SELF"] . ' method="post">' . 
				e("Username (Letters)") .
				'<br>
				<input style="width:250px" type="text" value="' . 
				$username . '" name="username" pattern="[ÅÄÖåäö a-zA-Z]{1,}" required><br>' .
				e("Email") . '<br> 	
				<input style="width:250px" type="userId" value="' .
				$userId . '" name="userId" required><br>' .
				e("PIN-code (Choose any combination of 4-6 numbers)") . '<br>
				<input style="width:250px" type="text" value="' .
				$pin . '" name="pin" pattern="[0-9]{1,}" required required><br>
				<br>
				<input type="submit" value="' . 
				e("Send") . '">
				</form>';
				
		}
		
		public function joinGroup($layer, $meeting, $userData){
			if (!file_exists(DATAPATH.$this->id."-"."start-".$layer."-".$meeting.".dat")) {
				$handle = fopen(DATAPATH.$this->id."-"."start-".$layer."-".$meeting.".dat", "w");
				fclose($handle);
			}
			$handle = fopen(DATAPATH.$this->id."-"."start-".$layer."-".$meeting.".dat", "rb");
			$contents = stream_get_contents($handle);
			fclose($handle);
			$users = explode("\n", $contents);

			if (!in_array($userData->userId, $users)) {
//				echo "new user joining";
				$myfile = fopen(DATAPATH.$this->id."-"."start-".$layer."-".$meeting.".dat", "a") or die("Unable to open file!");
				flock($myfile, LOCK_EX) or die("Unable to lock file");
				fwrite($myfile, $userData->userId . "\n");
				fflush($myfile);
				flock($myfile, LOCK_UN);
				fclose($myfile);
				$groupId = $this->getStartGroup($layer, $meeting, $userData->userId);
				$userData->layer->{$layer}->groupId = $groupId;
				$userData->layer->{$layer}->meetingId = $meeting;				
				$this->updateUserData($userData->userId, $userData);
				$groupData = $this->getGroupData($layer, $meeting, $groupId);
				$groupData->users[] = array ("userId" => $userData->userId, "repId" => "", "secId" => "");
				$this->updateGroupData($layer, $meeting, $groupId, $groupData);
				return $groupData;
			}
			return $this->getGroupData($layer, $meeting, $userData->layer->{$layer}->groupId);
			
		}
		
		public function getStartGroup($layer, $meeting, $userid) {
			if (!file_exists(DATAPATH.$this->id."-"."start-".$layer."-".$meeting.".dat")) {
				$handle = fopen(DATAPATH.$this->id."-"."start-".$layer."-".$meeting.".dat", "w");
				fclose($handle);
			}
			$handle = fopen(DATAPATH.$this->id."-"."start-".$layer."-".$meeting.".dat", "rb");
			$contents = stream_get_contents($handle);
			fclose($handle);
			$users = explode("\n", $contents);
			$key = array_search($userid, $users);
						
			if ($key===false)
				return false;
			return floor($key/$this->config->groupSize)+1;
		}
		
		public function getGroups($layer, $meeting) {
			if (!file_exists(DATAPATH.$this->id."-"."groups-".$layer."-".$meeting.".dat")) {
				$handle = fopen(DATAPATH.$this->id."-"."groups-".$layer."-".$meeting.".dat", "w");
				fclose($handle);
			}
			$handle = fopen(DATAPATH.$this->id."-"."groups-".$layer."-".$meeting.".dat", "rb");
			$contents = stream_get_contents($handle);
			fclose($handle);
			return $groups = explode("\n", $contents);
		}
		
		public function getGroupCount($layer, $meeting) {
			$groups = $this->getGroups($layer, $meeting);
			return floor(count($groups)/2);
		}
		
		public function getGroupData($layer, $meeting, $groupId) {
			$groups = $this->getGroups($layer, $meeting);
			$key = array_search("groupId:".$groupId, $groups);
			if ($key===false) {
				$groupData = new stdClass();
				$groupData->groupId = $groupId;
				$groupData->meetingId = $meeting;
				$this->updateGroupData($layer, $meeting, $groupId, $groupData);
				return $groupData;
			}
			$groupData = $groups[$key+1];
			// Fix, if group data users are missing, and next reccord contains users. An error in data has occured and this is a fix.
			
			if ($groupData->users==null){
				$_groupData = $groups[$key+2];
				if ($_groupData->users != null) {
//					$groupData->users = $_groupData->users;
				}
			}
				
			return json_decode($groupData);
		}
		
		public function getGroupRawData($layer, $meeting, $groupId) {
			$groups = $this->getGroups($layer, $meeting);
			$key = array_search("groupId:".$groupId, $groups);
			if ($key===false) {
				$groupData = array();
				$this->updateGroupData($layer, $meeting, $groupId, $groupData);
			}		
			$data = $groups[$key+1];
			return $data;
		}
		
		public function updateGroupData($layer, $meeting, $groupId, $groupData) {
						
			
			$groups = $this->getGroups($layer, $meeting);
			if (!$groupId)
				return;
			$key = array_search("groupId:".$groupId, $groups);
			if ($key === false) {
				$myfile = fopen(DATAPATH.$this->id."-"."groups-".$layer."-".$meeting.".dat", "a") or die("Unable to open file!");
				flock($myfile, LOCK_EX) or die("Unable to lock file");
				fwrite($myfile, "groupId:" . $groupId . "\n");
				fwrite($myfile, json_encode($groupData) . "\n");
				fflush($myfile);
				flock($myfile, LOCK_UN);
				fclose($myfile);
			}
			else {
				// fix to remove newlines
				$groups[$key+1] = str_replace(array("\n"),'', json_encode($groupData));
				$myfile = fopen(DATAPATH.$this->id."-"."groups-".$layer."-".$meeting.".dat", "w");
				flock($myfile, LOCK_EX) or die("Unable to lock file");			
				
			
				// Logging, print data to dump file
				
				$log = true;
				
				if ($log) {
					$logfile = fopen(DATAPATH.$this->id."-"."writelog.dat", "a");						
				}				
				
				foreach($groups as $line) {
					if ($line) {
						fwrite($myfile, $line . "\n");
						if ($log)
							fwrite($logfile, $line . "\n");
						
					}
				}
				fclose($myfile);
				
				if ($log)
					fclose($logfile);
				
			}
		}
	}


// General use public functions

	// For future languages
	function e($text){
		return ($text);
	}
	
	function ordinalNumber($num) {
		if (!in_array(($num % 100),array(11,12,13))) {
		  switch ($num % 10) {
			// Handle 1st, 2nd, 3rd
			case 1:  return $num.'st';
			case 2:  return $num.'nd';
			case 3:  return $num.'rd';
		  }
		}
		return $num.'th';
	}
	function input($id,$title,$value="") {
		echo "<b>" . $title . "</b><br>";
		echo "<input style='width:100%' id='m$id' name='$id' value='$value' type='text'><br>";
	}
	function inputDate($id,$title,$value="") {
		echo "<b>" . $title . "</b><br>";
		echo "<input class='datepicker' style='width:100%' id='m$id' name='$id' value='$value' type='text'><br>";
	}	
	function inputTextarea($id,$title,$value="") {
		echo "<b>" . $title . "</b><br>";
		echo "<textarea style='height:200px; width:100%' id='m$id' name='$id'>$value</textarea><br>";
	}	
	function inputHidden($id,$value) {
		echo "<input id='m$id' name='$id' type='hidden'><br>";
	}
	function addMeetingScript(){
		echo "<button class='btn btn-default' onclick='addMeeting()'>Add meeting</button>";
		include "./js/utl.js";

	}
	function inputStartDates() {
		echo "<div class='startDate'>";
		echo input("layer", "Layer (First=0)");
		echo inputHidden("meeting", "0");
		echo inputDate("date", "Date (YY-MM-DD HH:mm CET)");
		echo "</div>";
		echo "<button class='btn btn-default' onclick='deleteMeeting()'>Delete Meeting</button><br>";
		echo addMeetingScript();
	}
	function sendCreateMeetingForm($config) {		
		echo "<p>";
		echo input("title", "Meeting Title", $config->title);
		echo inputTextarea("desc", "Description", $config->desc[0]);
		echo inputTextarea("lastDesc", "Description for representative meetings", $config->lastDesc);
		echo inputTextarea("agenda", "Agenda", $config->agenda[0]);
		echo inputTextarea("lastAgenda", "Agenda for representative meetings", $config->lastAgenda);
		echo input("meetingLength", "Meeting length (min)", $config->meetingLength);
		echo input("repMeetingLength", "Meeting length (min) for representative meetings", $config->repMeetingLength);
		echo inputHidden("lobbyTime", "10");
		echo inputHidden("videoServer", "https://8x8.vc/fractalcircles");
		echo inputStartDates();
	}
	
	
?>